<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item style="float:right;">
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="['station:gun:add']">新增</el-button>
        <el-button icon="el-icon-delete" size="mini" @click="handleDelete" :disabled="multiple" v-hasPermi="['station:gun:remove']">删除</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="gunList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="油枪主键自增id" v-if="false" align="center" prop="oilGunId" />
      <el-table-column label="油枪号" align="center" prop="oilGunNo" />
      <el-table-column label="油品名称" align="center" prop="oilName" />
      <el-table-column label="单价" align="center" prop="oilPrice" />
      <el-table-column label="油站id" align="center" prop="stationId" v-if="false" />
      <el-table-column label="油站名称" align="center" prop="stationName" />
      <el-table-column label="操作时间" align="center" prop="date" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.date, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['station:gun:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['station:gun:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 添加或修改油枪管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="90px">
        <el-form-item label="油枪号" prop="oilGunNo">
          <el-input v-model="form.oilGunNo" placeholder="请输入油枪号" style="width: 150px"/>
        </el-form-item>
        <el-form-item label="油品名称" prop="oilName">
          <el-select v-model="form.oilName" placeholder="油品名称" clearable size="small" @change="onOilNameChang">
            <el-option
              v-for="dict in oilNameOptions"
              :key="dict.oilName"
              :label="dict.oilName"
              :value="dict.oilName"
            />
          </el-select> 
        </el-form-item>
        <el-form-item label="单价" prop="oilPrice" >
          <el-input-number v-model="form.oilPrice"  :precision="2" :disabled="flage" :step="1" style="width:150px;" ></el-input-number>元
        </el-form-item>
        <el-form-item label="油枪类型" v-show="false">
          <el-radio-group v-model="form.oilGunType" >
            <el-radio
              v-for="dict in oilGunTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictValue"
            >{{dict.dictLabel}}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listGun, getGun, delGun, addGun, updateGun, exportGun,stationinfo } from "@/api/station/gun";
import { listPrice,getPrice} from "@/api/station/price";
import { getDept } from "@/api/system/dept";
export default {
  name: "Gun",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 油枪管理表格数据
      gunList: [],
      //下拉油站
      stationOptions:[],
      statusOptions:[],
      oilNameOptions:[],
      oilGunTypeOptions:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      flage:true,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        oilGunNo: null,
        oilName: null,
        stationId: null,
        stationName: null,
        date: null,
        status: null
      },
      queryInfo:{
        stationId: null
      },    
      detpId:null,
      query:{
        deptId: null
      },
      // 表单参数
      form: {},
      deptInfo:{},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.query.deptId =this.$store.selectDeptId;
    if(this.query.deptId==null || this.query.deptId==""){
        this.query.deptId =this.$store.state.user.deptId;
      }
    stationinfo(this.query).then(response => {
      this.stationOptions = response.rows;
    });
    this.getDicts("station_gun_status").then(response => {
      this.statusOptions = response.data;
    });
   
    this.getDicts("oil_gun_type").then(response => {
      this.oilGunTypeOptions = response.data;
    });
  },
  methods: {
    async queryPrice(queryInfo ){
       const response = await listPrice(queryInfo);
       this.oilNameOptions = response.rows;
    },
    async queryOilPrice(oilPriceId ){
       const response = await getPrice(oilPriceId);
       this.form.oilPrice = response.data.oilPrice;
    },
  
    /** 查询油枪管理列表 */
    getList() {
      this.loading = true;
      this.queryParams.stationId=this.$store.selectDeptId;
      if(this.queryParams.stationId==null || this.queryParams.stationId==""){
        this.queryParams.stationId =this.$store.state.user.deptId;
      }
      listGun(this.queryParams).then(response => {
        this.gunList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        oilGunId: null,
        oilGunNo: null,
        oilName: null,
        stationId: null,
        stationName: null,
        date: null,
        status: "0"
      };
      this.resetForm("form");
      this.oilNameOptions.length=0;
      this.oilNameOptions = [];
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.oilGunId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      //判断当前登陆人下拉油站是否是油站
      this.deptId=this.$store.selectDeptId;
      if(this.deptId==null || this.deptId==""){
        this.deptId =this.$store.state.user.deptId;
      }
      getDept(this.deptId).then(response => {
          this.deptInfo = response.data;
          if(this.deptInfo.jiBie==2){
            this.open = true;
            this.form.oilGunType ="1";
            this.title = "添加油枪管理";
            this.form.stationId=this.deptInfo.deptId;
            this.form.stationName=this.deptInfo.deptName;
            this.queryInfo.stationId=this.deptInfo.deptId;
            this.queryPrice(this.queryInfo);
          }else{
              this.msgSuccess("请选择油站");
          }
      });
     
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const oilGunId = row.oilGunId || this.ids
      getGun(oilGunId).then(response => {
        this.form = response.data;
        if(this.form.stationId!=null && this.form.stationId!=""){
          this.queryInfo.stationId=this.form.stationId;
          listPrice(this.queryInfo).then(response => {
            this.oilNameOptions = response.rows;
          });
        }
        this.open = true;
        this.title = "修改油枪管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.oilGunId != null) {
            updateGun(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addGun(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    onInstitutionChang(e){
      let obj = {};
      obj = this.stationOptions.find((item)=>{//这里的userList就是上面遍历的数据源
          return item.deptId === e;//筛选出匹配数据
        })
      this.form.stationName=obj.deptName;
      //根据油站查询对应的油站内的所有油枪
      this.queryInfo.stationId=obj.deptId;
      listPrice(this.queryInfo).then(response => { 
        this.oilNameOptions = response.rows;
      });
    },
    onOilNameChang(e){
      let obj = {};
      if(e!=null &&e !=""){
        console.log("e",e);
        obj = this.oilNameOptions.find((item)=>{//这里的userList就是上面遍历的数据源
          return item.oilName === e;//筛选出匹配数据
        });
         console.log("obj",obj);
        if(obj.hasOwnProperty('oilName')){
          if(obj.oilName==="非油品"){
            this.form.oilGunType ="2";
          }else{
            this.form.oilGunType ="1";
          }
          if(obj.hasOwnProperty('oilPriceId')){
            // getPrice(obj.oilPriceId).then(response => {
            //    console.log("objoilPriceId",response);
            //   this.form.oilPrice = response.data.oilPrice;
            // });
            this.queryOilPrice(obj.oilPriceId);
          }else{
            this.form.oilPrice ="0";
          }
        }
      }else{
        this.form.oilPrice ="0";
      }
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const oilGunIds = row.oilGunId || this.ids;
      this.$confirm('是否确认删除油枪', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delGun(oilGunIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有油枪管理数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportGun(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
    // 菜单状态字典翻译
    statusFormat(row, column) {
      return this.selectDictLabel(this.statusOptions, row.status);
    }
  }
};
</script>
